#include<bits/stdc++.h>
using namespace std;
long long tochki[1000005];
int main(){
long long n;
//long long nachalo=-1,krai=-1;
long long koord[50005][2];
long long maks=0,br=0;
cin>>n;
for(long long i=0;i<n;i++){
    cin>>koord[i][0]>>koord[i][1];
    for(long long j=koord[i][0];j<koord[i][1];j++){
        tochki[j]++;
        if(tochki[j]>maks){
            maks=tochki[j];
            br=1;
        }else{
            if(tochki[j]==maks){
                br++;
            }
        }
    }
}
cout<<maks<<endl<<br<<endl;
return 0;
}